<template>
  <dialog-card :title="$t('dialogs.sync-upload.title')" :actions="actions">
    <v-card-text class="keep-line-breaks">
      {{ $t('dialogs.sync-upload.info.save') }}
    </v-card-text>
  </dialog-card>
</template>

<script lang="ts">
import type { Client } from '@/client';
import type { EditableUnit } from '@/data';
import { Component, Prop, Vue } from 'vue-property-decorator';

@Component
export default class SyncUploadDialog extends Vue {
  loading = false;

  @Prop({ required: true })
  client!: Client;

  @Prop({ required: true })
  path!: string;

  @Prop({ required: true })
  synchro!: EditableUnit;

  get actions() {
    return {
      cancel: {
        text: this.$t('generic.action.cancel'),
        handle: this.close,
      },
      upload: {
        text: this.$t('generic.action.upload'),
        handle: this.upload,
        loading: this.loading,
      },
    };
  }

  async upload() {
    const res = await this.client.uploadSync(this.path, this.synchro);
    return res;
  }

  close() {
    this.$emit('submit', false);
  }
}
</script>

<style lang="scss" scoped>
.keep-line-breaks {
  white-space: pre-line;
}
</style>
